

public class Point {
	
	//Member variables
	private double x, y;
	// Constructors 
	public Point(double x, double y) { this.x = x; this.y = y; }
	public Point() { this(0,0); }
	
	//Getters & Setters
	public double getX()         { return x; }
	public void   setX(double x) { this.x = x; }

	public double getY()         { return y; }
	public void   setY(double y) { this.y = y; }

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Point other = (Point) obj;
		if (Double.doubleToLongBits(x) != Double.doubleToLongBits(other.x))
			return false;
		if (Double.doubleToLongBits(y) != Double.doubleToLongBits(other.y))
			return false;
		return true;
	}

	public String toString() { return "Point [x=" + x + ", y=" + y + "]"; }
	
	// Methods
	// Distance by point
	public double distance(Point p) {
		return Math.sqrt(Math.pow(this.x-p.getX(), 2) + Math.pow(this.y-p.getY(), 2));
	}
	
	public boolean isWithin(Point p, double radius) { return this.distance(p) <= radius; }
}

